unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,
  ZIPStream, MediaSource; // tady je definovn TZIP

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button3Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button1Click(Sender: TObject);
var zip:TZIP;
    s:TFileStream;
    f:TStream;
begin
  //////////////////////////
  // Naten souboru ze zipu
  //////////////////////////
  Memo1.Lines.Clear;
  // 1.zskn streamu, ve kterm je zip uloen
  if not FileExists('a.zip') then exit;
  s:=TFileStream.Create('a.zip',fmOpenRead);
  // 2.vytvoen objektu zip
  zip:=TZIP.Create;
  try
    // 3.nastaven zdroje (z nj se pouze te)
    zip.ZipSource:=TStream(s);
    // 4.zskn TStream, kter obsahuje soubor editace.txt
    f:=zip.OpenFile('editace.txt');
    // 5.pouvn zskanho TStreamu
    Memo1.Lines.LoadFromStream(f);
  finally
    // 6.uzaven zskanho TStreamu
    zip.CloseFile(f);
    // 7.uvolnn zipu (neuvoluje ZipSource!)
    zip.Free;
    // 8.uvolnn souboru obsahujc zip (a.zip)
    s.Free;
  end;
  // Pozn. pouit SaveZIPtoStream(s) nelze pout, nebo pi ukldn
  // se zip postupn skld z uloench soubor (SaveToZIP) a ze soubor
  // nachzejcch se ve zdrojovm zipu (tedy v s) -> dolo by tedy
  // souasn ke ten i zpisu do jednoho streamu -> mus se otevt jin
  // TFileStream s jinm jmnem, pak pejmenovat soubor
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // po vytvoen formule se automaticky nate soubor editace.txt
  Button1Click(Self);
end;

procedure TForm1.Button2Click(Sender: TObject);
var zip:TZIP;
    s:TFileStream;
    f:TStream;
begin
  //////////////////////////
  // Uloen souboru do zipu
  //////////////////////////

  // 1.vytvoen clovho TStream
  s:=TFileStream.Create('a.zip',fmCreate);
  if s = nil then exit;
  // 2.vytvoen objektu z zip
  zip:=TZIP.Create;
  try
    // 3a - nen nutn vytvet ZipSource, kdy jen ukldme, a pedpokldme
    //      jen jeden soubor v zipu
    // 3.uloen souboru do zipu (mus bt cel soubor v pamti!)
    zip.SaveToZIP('editace.txt',PChar(Memo1.Lines.Text)^,Length(Memo1.Lines.Text),clMax);
    // 4.uloen zipu na disk (zde se teprve poskld z jednotlivch soubor)
    zip.SaveZIPToStream(s);
  finally
    // 5.uvolnn
    zip.Free;
    s.Free;
  end;
end;

end.
